(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs/operators'), require('rxjs/internal/operators'), require('@angular/core'), require('@angular/router'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ng7-bootstrap-breadcrumb', ['exports', 'rxjs/operators', 'rxjs/internal/operators', '@angular/core', '@angular/router', '@angular/common'], factory) :
    (factory((global['ng7-bootstrap-breadcrumb'] = {}),global.rxjs.operators,global.rxjs['internal/operators'],global.ng.core,global.ng.router,global.ng.common));
}(this, (function (exports,operators,operators$1,i0,router,common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Ng7BootstrapBreadcrumbService = /** @class */ (function () {
        function Ng7BootstrapBreadcrumbService() {
        }
        Ng7BootstrapBreadcrumbService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        Ng7BootstrapBreadcrumbService.ctorParameters = function () { return []; };
        /** @nocollapse */ Ng7BootstrapBreadcrumbService.ngInjectableDef = i0.defineInjectable({ factory: function Ng7BootstrapBreadcrumbService_Factory() { return new Ng7BootstrapBreadcrumbService(); }, token: Ng7BootstrapBreadcrumbService, providedIn: "root" });
        return Ng7BootstrapBreadcrumbService;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m)
            return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length)
                    o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Ng7BootstrapBreadcrumbComponent = /** @class */ (function () {
        function Ng7BootstrapBreadcrumbComponent(activatedRoute, router$$1) {
            this.activatedRoute = activatedRoute;
            this.router = router$$1;
            this.breadcrumb = [];
            this.breadCrumbData();
        }
        /**
         * @return {?}
         */
        Ng7BootstrapBreadcrumbComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        /**
         * @return {?}
         */
        Ng7BootstrapBreadcrumbComponent.prototype.breadCrumbData = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.router.events
                    .pipe(operators.filter(( /**
             * @param {?} event
             * @return {?}
             */function (event) { return event instanceof router.NavigationEnd; })))
                    .pipe(operators$1.map(( /**
             * @return {?}
             */function () { return _this.activatedRoute; })))
                    .pipe(operators$1.map(( /**
             * @param {?} route
             * @return {?}
             */function (route) {
                    while (route.firstChild) {
                        route = route.firstChild;
                    }
                    return route;
                })))
                    .pipe(operators.filter(( /**
             * @param {?} route
             * @return {?}
             */function (route) { return route.outlet === router.PRIMARY_OUTLET; })))
                    .subscribe(( /**
             * @param {?} route
             * @return {?}
             */function (route) {
                    if (route.snapshot.data.breadcrumb) {
                        /** @type {?} */
                        var breadcrumb = (JSON.parse(JSON.stringify(route.snapshot.data.breadcrumb)));
                        breadcrumb.map(( /**
                         * @param {?} crumb
                         * @return {?}
                         */function (crumb) {
                            var e_1, _a;
                            /** @type {?} */
                            var urlChunks = crumb.url.split('/');
                            try {
                                for (var urlChunks_1 = __values(urlChunks), urlChunks_1_1 = urlChunks_1.next(); !urlChunks_1_1.done; urlChunks_1_1 = urlChunks_1.next()) {
                                    var chunk = urlChunks_1_1.value;
                                    if (chunk.includes(':')) {
                                        /** @type {?} */
                                        var paramID = chunk.replace(':', '');
                                        /** @type {?} */
                                        var routerParamID = route.snapshot.params[paramID];
                                        crumb.url = crumb.url.replace(":" + paramID, routerParamID);
                                    }
                                }
                            }
                            catch (e_1_1) {
                                e_1 = { error: e_1_1 };
                            }
                            finally {
                                try {
                                    if (urlChunks_1_1 && !urlChunks_1_1.done && (_a = urlChunks_1.return))
                                        _a.call(urlChunks_1);
                                }
                                finally {
                                    if (e_1)
                                        throw e_1.error;
                                }
                            }
                        }));
                        _this.breadcrumb = breadcrumb;
                    }
                    else {
                        _this.breadcrumb = [];
                    }
                }));
            };
        Ng7BootstrapBreadcrumbComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'app-ng7-bootstrap-breadcrumb',
                        template: "<nav aria-label=\"breadcrumb\">\n    <ol class=\"breadcrumb\" *ngIf=\"breadcrumb.length\">\n        <ng-container *ngFor=\"let item of breadcrumb; let i = index\">\n            <li class=\"breadcrumb-item\" [ngClass]=\"{'active': breadcrumb.length !== i+1}\">\n                <a *ngIf=\"item?.url\" [routerLink]=\"item?.url\">{{ item.label }}</a>\n                <span *ngIf=\"!item?.url\">{{ item.label }}</span>\n            </li>\n        </ng-container>\n    </ol>\n</nav>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        Ng7BootstrapBreadcrumbComponent.ctorParameters = function () {
            return [
                { type: router.ActivatedRoute },
                { type: router.Router }
            ];
        };
        return Ng7BootstrapBreadcrumbComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Ng7BootstrapBreadcrumbModule = /** @class */ (function () {
        function Ng7BootstrapBreadcrumbModule() {
        }
        Ng7BootstrapBreadcrumbModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [Ng7BootstrapBreadcrumbComponent],
                        imports: [
                            router.RouterModule,
                            common.CommonModule
                        ],
                        exports: [Ng7BootstrapBreadcrumbComponent]
                    },] }
        ];
        return Ng7BootstrapBreadcrumbModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.Ng7BootstrapBreadcrumbService = Ng7BootstrapBreadcrumbService;
    exports.Ng7BootstrapBreadcrumbComponent = Ng7BootstrapBreadcrumbComponent;
    exports.Ng7BootstrapBreadcrumbModule = Ng7BootstrapBreadcrumbModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ng7-bootstrap-breadcrumb.umd.js.map