import { __values } from 'tslib';
import { filter } from 'rxjs/operators';
import { map } from 'rxjs/internal/operators';
import { Injectable, NgModule, defineInjectable, Component } from '@angular/core';
import { ActivatedRoute, Router, NavigationEnd, PRIMARY_OUTLET, RouterModule } from '@angular/router';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var Ng7BootstrapBreadcrumbService = /** @class */ (function () {
    function Ng7BootstrapBreadcrumbService() {
    }
    Ng7BootstrapBreadcrumbService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    Ng7BootstrapBreadcrumbService.ctorParameters = function () { return []; };
    /** @nocollapse */ Ng7BootstrapBreadcrumbService.ngInjectableDef = defineInjectable({ factory: function Ng7BootstrapBreadcrumbService_Factory() { return new Ng7BootstrapBreadcrumbService(); }, token: Ng7BootstrapBreadcrumbService, providedIn: "root" });
    return Ng7BootstrapBreadcrumbService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var Ng7BootstrapBreadcrumbComponent = /** @class */ (function () {
    function Ng7BootstrapBreadcrumbComponent(activatedRoute, router) {
        this.activatedRoute = activatedRoute;
        this.router = router;
        this.breadcrumb = [];
        this.breadCrumbData();
    }
    /**
     * @return {?}
     */
    Ng7BootstrapBreadcrumbComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @return {?}
     */
    Ng7BootstrapBreadcrumbComponent.prototype.breadCrumbData = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.router.events
            .pipe(filter((/**
         * @param {?} event
         * @return {?}
         */
        function (event) { return event instanceof NavigationEnd; })))
            .pipe(map((/**
         * @return {?}
         */
        function () { return _this.activatedRoute; })))
            .pipe(map((/**
         * @param {?} route
         * @return {?}
         */
        function (route) {
            while (route.firstChild) {
                route = route.firstChild;
            }
            return route;
        })))
            .pipe(filter((/**
         * @param {?} route
         * @return {?}
         */
        function (route) { return route.outlet === PRIMARY_OUTLET; })))
            .subscribe((/**
         * @param {?} route
         * @return {?}
         */
        function (route) {
            if (route.snapshot.data.breadcrumb) {
                /** @type {?} */
                var breadcrumb = (JSON.parse(JSON.stringify(route.snapshot.data.breadcrumb)));
                breadcrumb.map((/**
                 * @param {?} crumb
                 * @return {?}
                 */
                function (crumb) {
                    var e_1, _a;
                    /** @type {?} */
                    var urlChunks = crumb.url.split('/');
                    try {
                        for (var urlChunks_1 = __values(urlChunks), urlChunks_1_1 = urlChunks_1.next(); !urlChunks_1_1.done; urlChunks_1_1 = urlChunks_1.next()) {
                            var chunk = urlChunks_1_1.value;
                            if (chunk.includes(':')) {
                                /** @type {?} */
                                var paramID = chunk.replace(':', '');
                                /** @type {?} */
                                var routerParamID = route.snapshot.params[paramID];
                                crumb.url = crumb.url.replace(":" + paramID, routerParamID);
                            }
                        }
                    }
                    catch (e_1_1) { e_1 = { error: e_1_1 }; }
                    finally {
                        try {
                            if (urlChunks_1_1 && !urlChunks_1_1.done && (_a = urlChunks_1.return)) _a.call(urlChunks_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                    }
                }));
                _this.breadcrumb = breadcrumb;
            }
            else {
                _this.breadcrumb = [];
            }
        }));
    };
    Ng7BootstrapBreadcrumbComponent.decorators = [
        { type: Component, args: [{
                    selector: 'app-ng7-bootstrap-breadcrumb',
                    template: "<nav aria-label=\"breadcrumb\">\n    <ol class=\"breadcrumb\" *ngIf=\"breadcrumb.length\">\n        <ng-container *ngFor=\"let item of breadcrumb; let i = index\">\n            <li class=\"breadcrumb-item\" [ngClass]=\"{'active': breadcrumb.length !== i+1}\">\n                <a *ngIf=\"item?.url\" [routerLink]=\"item?.url\">{{ item.label }}</a>\n                <span *ngIf=\"!item?.url\">{{ item.label }}</span>\n            </li>\n        </ng-container>\n    </ol>\n</nav>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    Ng7BootstrapBreadcrumbComponent.ctorParameters = function () { return [
        { type: ActivatedRoute },
        { type: Router }
    ]; };
    return Ng7BootstrapBreadcrumbComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var Ng7BootstrapBreadcrumbModule = /** @class */ (function () {
    function Ng7BootstrapBreadcrumbModule() {
    }
    Ng7BootstrapBreadcrumbModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [Ng7BootstrapBreadcrumbComponent],
                    imports: [
                        RouterModule,
                        CommonModule
                    ],
                    exports: [Ng7BootstrapBreadcrumbComponent]
                },] }
    ];
    return Ng7BootstrapBreadcrumbModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { Ng7BootstrapBreadcrumbService, Ng7BootstrapBreadcrumbComponent, Ng7BootstrapBreadcrumbModule };

//# sourceMappingURL=ng7-bootstrap-breadcrumb.js.map